#include "hookthread.h"
#include <cmath>
#include <ctime>
HookThread* HookThread::hInstance = 0;
void HookThread::run()
{
	px = 0;
	leftMouse = 0;
	rightMouse = 0;
	//stopHook = false;
	hInstance = this;
	#ifdef WIN32
	HINSTANCE h = ::GetModuleHandle((WCHAR*)QApplication::applicationFilePath().utf16());
	
	hMouseHook = SetWindowsHookEx(WH_MOUSE_LL, &mouseHook, h, 0);
	#else
	Display *display = QX11Info::display();
	Window grab_window = oWidget->winId();
	Bool owner_events = true;
	unsigned int event_mask = ButtonPressMask | PointerMotionMask;	
	int pointer_mode = GrabModeAsync, keyboard_mode = GrabModeAsync; 
	Window confine_to = QX11Info::appRootWindow(); 
	Cursor cursor = 0; 
	Time time = CurrentTime; 
	XGrabPointer(display, grab_window, owner_events, event_mask, pointer_mode,
               keyboard_mode, confine_to, cursor, time);
	
   	#endif
   exec();
}
#ifdef WIN32
LRESULT CALLBACK HookThread::mouseHook(int nCode, WPARAM wParam, LPARAM lParam)
{
	MSLLHOOKSTRUCT  *mStruct = (MSLLHOOKSTRUCT *)lParam;
	hInstance->oldMousePos = hInstance->mousePos;
	hInstance->mousePos = QPointF(mStruct->pt.x, mStruct->pt.y);
	switch (wParam)
	{
		case WM_LBUTTONDOWN:
			hInstance->leftMouse+=1;
			break;
		case WM_RBUTTONDOWN:
			hInstance->rightMouse+=1;
			break;
		case WM_MOUSEWHEEL:
			hInstance->mouseDelta = (short)((mStruct->mouseData >> 16) & 0xffff);
			break;
	}
	int x = (qMax(hInstance->oldMousePos.x(),hInstance->mousePos.x()) - 
					qMin(hInstance->oldMousePos.x(), hInstance->mousePos.x()));
	int y = (qMax(hInstance->oldMousePos.y(),hInstance->mousePos.y()) - 
					qMin(hInstance->oldMousePos.y(), hInstance->mousePos.y()));
	hInstance->px += sqrt(pow(x,2)+pow(y,2));
	hInstance->mmins += (sqrt(pow(x,2)+pow(y,2))*25.4)/hInstance->dpi;
	emit hInstance->mouseHooked();
	return CallNextHookEx(hInstance->hMouseHook, nCode, wParam, lParam);
}
#endif


