#ifndef HOOKTHREAD_H_
#define HOOKTHREAD_H_

#include <QtGui>
#include <QThread>
#ifdef WIN32
#define _WIN32_WINNT 0x0500
#define WINVER 0x0500
#include <windows.h>
#else

#include <QX11Info>
#include <X11/Xatom.h>
#include <X11/Xlib.h>
#endif
class HookThread : public QThread
{
    Q_OBJECT
public:
    void run();
	static HookThread* instance();
	
	// Mouse implementation
	//set Parameters
	void setDpi(int v){dpi = v;}
	void setPx(int v){px = v;}
	void setMeterInSec(int v){mmins = v;}
	void setLeftClicks(int v){leftMouse = v;}
	void setRightClicks(int v){rightMouse = v;}
	void setMousePos(QPointF v){mousePos = v;}
	void setOldMousePos(QPointF v){oldMousePos = v;}
	void setMouseDelta(double v){mouseDelta = v;}
	//get Parameters
	int getDpi(){return dpi;}
	double getPx(){return px;}
	double getMeterInSec(){return mmins;}
	int getLeftClicks(){return leftMouse;}
	int getRightClicks(){return rightMouse;}
	QPointF getMousePos(){return mousePos;}
	QPointF getOldMousePos(){return oldMousePos;}
	double getMouseDelta(){return mouseDelta;}
	//void stopHook(int v){dpi = v;}
	
signals:
	void mouseHooked();
private:
	//Mouse
	int dpi;
    double px;
	double mmins;
	QPointF mousePos, oldMousePos;
	int leftMouse, rightMouse;
	double mouseDelta;

	
	//Keyboard
	//bool stopHook;
	//thread
	static HookThread* hInstance;
#ifdef WIN32
public:
	
	HHOOK getMouseHook(){return hMouseHook;}
	static LRESULT CALLBACK mouseHook(int nCode, WPARAM wParam, LPARAM lParam);
private:
	HHOOK hMouseHook;
#endif
};

inline HookThread* HookThread::instance()
{
   return HookThread::hInstance;
}
#endif
